#include <stdint.h>
#include <unistd.h>

typedef uint32_t pixel;
#include "video_sdl1.c"
#include "point.c"

int main(int argc, char *argv[])
{
	Point3D p30, p31, p32, p33;
	Point2D p20, p21, p22, p23;
	Camera C;
	SDL_Event event;
	char r, kd, fd;
	int sym, mod, delay;

	if (argv[argc - 1] == NULL){} // silences warning

	sym = 0;
	mod = 0;
	kd = 0;
	delay = 0;
	fd = 0;

	p30.x = -0.15;
	p30.y = -0.15;
	p30.z = 0.15;
	p31.x = 0.15;
	p31.y = -0.15;
	p31.z = 0.15;
	p32.x = 0.15;
	p32.y = 0.15;
	p32.z = 0.15;
	p33.x = -0.15;
	p33.y = 0.15;
	p33.z = 0.15;

	C.x = 0.0;
	C.y = 0.0;
	C.z = -0.25;
	ChangeCameraThetaX(&C, 0.0, 1);
	ChangeCameraThetaY(&C, 0.0, 1);
	ChangeCameraThetaZ(&C, 0.0, 1);

	open_main_window(640, 480);

	r = 1;
	while (r)
	{
		if (SDL_PollEvent(&event))
		{
			if (event.type == SDL_KEYDOWN)
			{
				sym = event.key.keysym.sym;
				mod = event.key.keysym.mod;
				printf("%d\n", sym);
				kd = 1;
				delay = 20;
			}
			if (event.type == SDL_KEYUP)
			{
				kd = 0;
				fd = 1;
			}
		}
		if (fd || (kd && !(--delay)))
		{
			fd = 0;
			delay = 1;
			if (!p20.beyond)
			{
				*(calc_first_pixel_address_of_area(p20.ix, p20.iy)) = 0xff000000;
				update_area(p20.ix, p20.iy, 1, 1);
			}
			if (!p21.beyond)
			{
				*(calc_first_pixel_address_of_area(p21.ix, p21.iy)) = 0xff000000;
				update_area(p21.ix, p21.iy, 1, 1);
			}
			if (!p22.beyond)
			{
				*(calc_first_pixel_address_of_area(p22.ix, p22.iy)) = 0xff000000;
				update_area(p22.ix, p22.iy, 1, 1);
			}
			if (!p23.beyond)
			{
				*(calc_first_pixel_address_of_area(p23.ix, p23.iy)) = 0xff000000;
				update_area(p23.ix, p23.iy, 1, 1);
			}
			switch (sym)
			{
				case 27: // ESCAPE
					r = 0;
				break;
				case 258: // NUMPAD 2
					ChangeCameraThetaX(&C, -0.01, 0);
				break;
				case 260: // NUMPAD 4
					ChangeCameraThetaZ(&C, 0.01, 0);
				break;
				case 262: // NUMPAD 6
					ChangeCameraThetaZ(&C, -0.01, 0);
				break;
				case 264: // NUMPAD 8
					ChangeCameraThetaX(&C, 0.01, 0);
				break;
				case 269: // NUMPAD -
					CameraMove(&C, 0.0, 0.01, 0.0);
				break;
				case 270: // NUMPAD +
					CameraMove(&C, 0.0, -0.01, 0.0);
				break;
				case 273: // CURSOR UP
					CameraMove(&C, 0.0, 0.0, 0.01);
				break;
				case 274: // CURSOR DOWN
					CameraMove(&C, 0.0, 0.0, -0.01);
				break;
				case 275: // CURSOR RIGHT
					if (mod & KMOD_ALT)
					{
						CameraMove(&C, 0.01, 0.0, 0.0);
					}
					else
					{
						ChangeCameraThetaY(&C, 0.01, 0);
					}
				break;
				case 276: // CURSOR LEFT
					if (mod & KMOD_ALT)
					{
						CameraMove(&C, -0.01, 0.0, 0.0);
					}
					else
					{
						ChangeCameraThetaY(&C, -0.01, 0);
					}
				break;
			}
			printf("%f, %f, %f, %f, %f, %f\n", C.x, C.y, C.z, C.thx, C.thy, C.thz);
			TransformPoint3DToPoint2D(&p30, &C, &p20, 640, 480);
			TransformPoint3DToPoint2D(&p31, &C, &p21, 640, 480);
			TransformPoint3DToPoint2D(&p32, &C, &p22, 640, 480);
			TransformPoint3DToPoint2D(&p33, &C, &p23, 640, 480);
			printf("%f, %f => %d, %d\n", p20.x, p20.y, p20.ix, p20.iy);
			printf("%f, %f => %d, %d\n", p21.x, p21.y, p21.ix, p21.iy);
			printf("%f, %f => %d, %d\n", p22.x, p22.y, p22.ix, p22.iy);
			printf("%f, %f => %d, %d\n", p23.x, p23.y, p23.ix, p23.iy);
			if (!p20.beyond)
			{
				*(calc_first_pixel_address_of_area(p20.ix, p20.iy)) = 0xffffffff;
				update_area(p20.ix, p20.iy, 1, 1);
			}
			if (!p21.beyond)
			{
				*(calc_first_pixel_address_of_area(p21.ix, p21.iy)) = 0xffffffff;
				update_area(p21.ix, p21.iy, 1, 1);
			}
			if (!p22.beyond)
			{
				*(calc_first_pixel_address_of_area(p22.ix, p22.iy)) = 0xffffffff;
				update_area(p22.ix, p22.iy, 1, 1);
			}
			if (!p23.beyond)
			{
				*(calc_first_pixel_address_of_area(p23.ix, p23.iy)) = 0xffffffff;
				update_area(p23.ix, p23.iy, 1, 1);
			}
			swap_buffers();
		}
		usleep(40000);
	}
	close_main_window();
	return 0;
}
